<template>
    <div class="">
            <page-header title="Historiques">
              <div slot="nav">
                <div class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a :href="excelUrl"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                    </div>
                    </div>
              </div>
            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title">
                            <vc-date-picker color="red" :input-props='{
                                class: "form-control ml-3 ",
                                placeholder: "Entrez un filtre temporel",
                                readonly: true
                              }'  :columns="$screens({ default: 1, lg: 2 })"  @input="datepickerEvent" :masks="mask" mode="range" v-model="periode" 
                           
                            >

                    </vc-date-picker>
                    </h3>

                    <div class="card-tools d-flex">
                          <select name="" id="" class="filter form-control mr-1" @change="filterUserEvent">
                            <option value="">Tous les utilisateurs</option>
                            <option :value="utilisateur.id" v-for="utilisateur in utilisateurs" :key="utilisateur.id" v-text="utilisateur.name">Choisissez un utilisateur</option>
                             
                          </select>
                         <filter-bar class="recherche" ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive  p-0 position-relative " v-show="!NoDataForSearch && !NoDataAtAll" >
                    <vuetable
                     :css="table" ref="vuetable" 
                     api-url="api/historiques"
                      :fields="columns" 
                           pagination-path=""
                           :per-page="15"
                           @vuetable:loading="onLoading" 
                           @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams" 
                           :http-options="httpOptions"
                           @vuetable:pagination-data="onPaginationData">
                            <template slot="description" slot-scope="props">   
                            <div class="custom-actions" v-html="props.rowData.as_someone_else">
                            </div>
                            </template>
                           <template slot="type" slot-scope="props">   
                            <div class="custom-actions">
                            
                                        <span class="badge badge-warning text-uppercase" v-if="props.rowData.description=='connexion'">
                                              {{props.rowData.description}}
                                        </span>
                                        <span  class="badge badge-danger text-uppercase" v-else-if="props.rowData.description=='deconnexion'">
                                              {{props.rowData.description}} 
                                        </span>
                                        <span  class="badge badge-secondary text-uppercase" v-else-if="props.rowData.description=='created'">
                                              création 
                                        </span>
                                        <span  class="badge badge-secondary text-uppercase" v-else-if="props.rowData.description=='deleted'">
                                              suppréssion 
                                        </span>
                                        <span  class="badge badge-secondary text-uppercase" v-else-if="props.rowData.description=='updated'">
                                              Modification
                                        </span>
                                        <span class="badge badge-secondary text-uppercase" v-else>
                                              {{props.rowData.description}}
                                        </span>
                                
                            </div>
                            </template>
                    </vuetable>
              </div>
              <pa ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>
              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
              <!-- Modal dbt -->
</div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../../components/pagination/Pagination'
   import Form from "./../../../classes/Form"
   import Master from "./../../Master.vue";


    export default {
        mixins: [Master],
        data(){
            return{

                //Attributs de la date
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                  },
                periode:"",

                modeEdit:false,
                ftime:true,
                hasData:false,
                crud:"created,updated,deleted",
                utilisateurs : [],
                utilisateur:'',
                moreParams:{
                  filter:"",
                  filter_utilisateur:'',
                  filter_date_dbt:moment().subtract(30,'days').format('YYYY-MM-DD'),
                  filter_date_dbt:moment().format('YYYY-MM-DD')
                },
                isLoading:false,
                columns : [
                {
                name: '__slot:description',   // <----
                title: 'Description'
                },
                {
                name: '__slot:type',   // <----
                title: 'Type',
                                titleClass: 'center aligned',
                dataClass: 'center aligned'
                },
                {
                    name: 'created_at',
                    title: "Date d'enregistrement",
                    titleClass: 'text-right ',
                    dataClass: 'text-right pl-0 ',
                    callback: 'formatDate|D-MM-Y à H:mm'
                },
                
                ],
                  table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
            this.periode =
            {
              start:moment().subtract(30,'days').toDate(),
              end:moment().toDate()
            }
            this.modeEdit = false
            axios.get("/api/dispatcher/options/historiques").then((response) => 
            { 
               this.utilisateurs = response.data.utilisateurs

            },
            (error) =>
            {
            });
        },
        mounted() {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
        {
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'un rôle"  : " Ajout d'un rôle"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },
           excelUrl()
           {
             return '/historiques/export?format=excel&filter='+this.moreParams.filter+'&filter_date_fin_prev='+this.moreParams.filter_date_fin_prev+'&filter_date_dbt='+this.moreParams.filter_date_dbt+'&utilisateur='+this.moreParams.filter_utilisateur
           },
        },
        methods: 
        {
            datepickerEvent(periode)
            {
                 this.moreParams.filter_date_dbt = moment(periode.start).format('YYYY-MM-DD')
                 this.moreParams.filter_date_fin_prev = moment(periode.end).format('YYYY-MM-DD')
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
                limitText (count) {
              return `et ${count} en plus`
            },
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            //Recupere le libellé d'un utilisateur
            getRole(value)
            {
               var elem = this.$refs.vuetable.tableData.find( e => e.utilisateur_id == value);
               if(elem.utilisateur!=null)
                 return elem.utilisateur.libelle
               else
                 return "-"
            },
            onPaginationData (paginationData) 
            {
              var historiques = paginationData
              if(this.pageInit==false)
              {
                 this.pageInit =true
              }
              else
              {
                
              }
              this.hasData = historiques.data.length > 0
              this.$refs.vuetable.tablePagination =historiques
              this.$refs.vuetable.tableData = historiques.data
              this.$refs.pagination.setPaginationData(historiques)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
            filterUserEvent(e)
            {
                 this.moreParams.filter_utilisateur= e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterSet (filterText) {
                this.moreParams.filter = filterText
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            //Retire un utilisateur de la BDD
             remove(e)
             {
                 
                  
                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer ceet utilisateur ?","Suppréssion d'un utilisateur")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                           axios.delete("api/utilisateurs/"+e).then((response) => 
                            { 
                             // on rafraichit la page de donnée actuelle
                              !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()
                              //on notifie l'effectivité de la suppréssion
                              flash(response.data.message)
                              //On réinitialise le chargement
                              this.isLoading = false


                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
             },
             //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Si on edite pas
                if(!this.modeEdit)
                  //on ajoute un nouveau
                   this.add()
                else 
                //alors on actualise
                  this.update()
             },
            //Ajoute un utilisateur dans la BDD
            add()
            {
                //Requête ajax
                this.form.post("api/utilisateurs").then((value) => 
                {  
                  this.reset()
                  // on ramène les données sur la page 1
                  this.$refs.vuetable.refresh()
                  flash("<span>Enregistré <strong>avec succès</strong></span>")

                },
                (error) =>
                {
                  this.isLoading = false
                  flash("<span>Ajout<strong>impossible</strong></span>","error")
                  this.reset()
                });                  
            },
            //Actualise  un utilisateur dans la BDD
            update()
            {
              
                //Requête ajax
                this.form.patch("api/utilisateurs/"+this.form.id).then((value) => 
                {
                  
                   // on rafraichit la page des données actuelle
                  this.$refs.vuetable.reload()
                  //On remet à zero notre formulaire
                  this.reset()
                  //on affiche le message 
                  flash("<span>Modifié <strong>avec succès</strong></span>")
                  

                },
                (error) =>
                {
                  this.isLoading = false
                  //on affiche le message 
                  flash("<span>Modification<strong>impossible</strong></span>","error")
                  this.reset()
                });                  
            },
            //On affiche le modal pour la création
            showModalOnCreate()
            {
    
                this.modeEdit = false
                this.reset()
                this.$refs['inputModal'].show()
              
            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {
               
                this.reset()
                this.modeEdit = true
                this.form.name = entity.name
                this.form.email =entity.email
                this.form.utilisateur_id=entity.utilisateur_id
                this.form.id=entity.id
                this.utilisateur = entity.utilisateur
                this.$refs['inputModal'].show()
             },
              //Initialisation du formulaire
              reset()
             {
                
                  this.form.name = ""
                  this.form.email =""
                  this.form.utilisateur_id=""
                  this.$refs['inputModal'].hide()
                  this.utilisateur = ""
                  this.modeEdit = false
                  this.isLoading = false
                  this.moreParams.filter=""
             },
              multiSelect(e,name)
             {
                 if(e!=null)
                 {
                   this.form.utilisateur_id = e.id
                 }
                  if(this.form.errors.has(name))
                  this.form.errors.clear(name)
             },
              
        },
        components:
        {

            Vuetable,
            pa
        }
    }
</script>
<style scoped>
.card-tools .filter
{
  flex:1
}
.card-tools .recherhce
{
  flex:1
}
.vuetable-slot .badge
{
  min-width: 80px !important;
}
</style>